Chapter 43. PodService


43.1. ExportPods

GET /v1/export/pods

43.1.1. Description

43.1.2. Parameters

43.1.2.1. Query Parameters

Expand
NameDescriptionRequiredDefaultPattern

timeout

 

-

null

 

query

 

-

null

 

43.1.3. Return Type

Stream_result_of_v1ExportPodResponse

43.1.4. Content Type

  • application/json

43.1.5. Responses

Expand
Table 43.1. HTTP Response Codes
CodeMessageDatatype

200

A successful response.(streaming responses)

Stream_result_of_v1ExportPodResponse

0

An unexpected error response.

RuntimeError

43.1.6. Samples

43.1.7. Common object reference

43.1.7.1. PodContainerInstanceList

Expand
Field NameRequiredNullableTypeDescriptionFormat

instances

  

List of StorageContainerInstance

  

43.1.7.2. ProtobufAny

Any contains an arbitrary serialized protocol buffer message along with a URL that describes the type of the serialized message.

Protobuf library provides support to pack/unpack Any values in the form of utility functions or additional generated methods of the Any type.

Example 1: Pack and unpack a message in C++.

Foo foo = ...;
Any any;
any.PackFrom(foo);
...
if (any.UnpackTo(&foo)) {
  ...
}

Example 2: Pack and unpack a message in Java.

Foo foo = ...;
Any any = Any.pack(foo);
...
if (any.is(Foo.class)) {
  foo = any.unpack(Foo.class);
}
// or ...
if (any.isSameTypeAs(Foo.getDefaultInstance())) {
  foo = any.unpack(Foo.getDefaultInstance());
}
Example 3: Pack and unpack a message in Python.
foo = Foo(...)
any = Any()
any.Pack(foo)
...
if any.Is(Foo.DESCRIPTOR):
  any.Unpack(foo)
  ...
Example 4: Pack and unpack a message in Go
foo := &pb.Foo{...}
any, err := anypb.New(foo)
if err != nil {
  ...
}
...
foo := &pb.Foo{}
if err := any.UnmarshalTo(foo); err != nil {
  ...
}

The pack methods provided by protobuf library will by default use 'type.googleapis.com/full.type.name' as the type URL and the unpack methods only use the fully qualified type name after the last '/' in the type URL, for example "foo.bar.com/x/y.z" will yield type name "y.z".

43.1.7.2.1. JSON representation

The JSON representation of an Any value uses the regular representation of the deserialized, embedded message, with an additional field @type which contains the type URL. Example:

package google.profile;
message Person {
  string first_name = 1;
  string last_name = 2;
}
{
  "@type": "type.googleapis.com/google.profile.Person",
  "firstName": <string>,
  "lastName": <string>
}

If the embedded message type is well-known and has a custom JSON representation, that representation will be embedded adding a field value which holds the custom JSON in addition to the @type field. Example (for message [google.protobuf.Duration][]):

{
  "@type": "type.googleapis.com/google.protobuf.Duration",
  "value": "1.212s"
}
Expand
Field NameRequiredNullableTypeDescriptionFormat

typeUrl

  

String

A URL/resource name that uniquely identifies the type of the serialized protocol buffer message. This string must contain at least one \"/\" character. The last segment of the URL’s path must represent the fully qualified name of the type (as in path/google.protobuf.Duration). The name should be in a canonical form (e.g., leading \".\" is not accepted). In practice, teams usually precompile into the binary all types that they expect it to use in the context of Any. However, for URLs which use the scheme http, https, or no scheme, one can optionally set up a type server that maps type URLs to message definitions as follows: * If no scheme is provided, https is assumed. * An HTTP GET on the URL must yield a [google.protobuf.Type][] value in binary format, or produce an error. * Applications are allowed to cache lookup results based on the URL, or have them precompiled into a binary to avoid any lookup. Therefore, binary compatibility needs to be preserved on changes to types. (Use versioned type names to manage breaking changes.) Note: this functionality is not currently available in the official protobuf release, and it is not used for type URLs beginning with type.googleapis.com. As of May 2023, there are no widely used type server implementations and no plans to implement one. Schemes other than http, https (or the empty scheme) might be used with implementation specific semantics.

 

value

  

byte[]

Must be a valid serialized protocol buffer of the above specified type.

byte

43.1.7.3. RuntimeError

Expand
Field NameRequiredNullableTypeDescriptionFormat

error

  

String

  

code

  

Integer

 

int32

message

  

String

  

details

  

List of ProtobufAny

  

43.1.7.4. RuntimeStreamError

Expand
Field NameRequiredNullableTypeDescriptionFormat

grpcCode

  

Integer

 

int32

httpCode

  

Integer

 

int32

message

  

String

  

httpStatus

  

String

  

details

  

List of ProtobufAny

  

43.1.7.5. StorageContainerInstance

ContainerInstanceID allows to uniquely identify a container within a cluster.

Expand
Field NameRequiredNullableTypeDescriptionFormat

instanceId

  

StorageContainerInstanceID

  

containingPodId

  

String

The pod containing this container instance (kubernetes only).

 

containerName

  

String

Container name.

 

containerIps

  

List of string

The IP addresses of this container.

 

started

  

Date

 

date-time

imageDigest

  

String

  

finished

  

Date

The finish time of the container, if it finished.

date-time

exitCode

  

Integer

The exit code of the container. Only valid when finished is populated.

int32

terminationReason

  

String

The reason for the container’s termination, if it finished.

 

43.1.7.6. StorageContainerInstanceID

Expand
Field NameRequiredNullableTypeDescriptionFormat

containerRuntime

  

StorageContainerRuntime

 

UNKNOWN_CONTAINER_RUNTIME, DOCKER_CONTAINER_RUNTIME, CRIO_CONTAINER_RUNTIME,

id

  

String

The ID of the container, specific to the given runtime.

 

node

  

String

The node on which this container runs.

 

43.1.7.7. StorageContainerRuntime

Expand
Enum Values

UNKNOWN_CONTAINER_RUNTIME

DOCKER_CONTAINER_RUNTIME

CRIO_CONTAINER_RUNTIME

43.1.7.8. StoragePod

Pod represents information for a currently running pod or deleted pod in an active deployment.

Expand
Field NameRequiredNullableTypeDescriptionFormat

id

  

String

  

name

  

String

  

deploymentId

  

String

  

namespace

  

String

  

clusterId

  

String

  

liveInstances

  

List of StorageContainerInstance

  

terminatedInstances

  

List of PodContainerInstanceList

Must be a list of lists, so we can perform search queries (does not work for maps that aren’t <string, string>) There is one bucket (list) per container name.

 

started

  

Date

Time Kubernetes reports the pod was created.

date-time

43.1.7.9. StreamResultOfV1ExportPodResponse

Stream result of v1ExportPodResponse
Expand
Field NameRequiredNullableTypeDescriptionFormat

result

  

V1ExportPodResponse

  

error

  

RuntimeStreamError

  

43.1.7.10. V1ExportPodResponse

Expand
Field NameRequiredNullableTypeDescriptionFormat

pod

  

StoragePod

  

43.2. GetPods

GET /v1/pods

GetPods returns the pods.

43.2.1. Description

43.2.2. Parameters

43.2.2.1. Query Parameters

Expand
NameDescriptionRequiredDefaultPattern

query

 

-

null

 

pagination.limit

 

-

null

 

pagination.offset

 

-

null

 

pagination.sortOption.field

 

-

null

 

pagination.sortOption.reversed

 

-

null

 

pagination.sortOption.aggregateBy.aggrFunc

 

-

UNSET

 

pagination.sortOption.aggregateBy.distinct

 

-

null

 

43.2.3. Return Type

V1PodsResponse

43.2.4. Content Type

  • application/json

43.2.5. Responses

Expand
Table 43.2. HTTP Response Codes
CodeMessageDatatype

200

A successful response.

V1PodsResponse

0

An unexpected error response.

RuntimeError

43.2.6. Samples

43.2.7. Common object reference

43.2.7.1. PodContainerInstanceList

Expand
Field NameRequiredNullableTypeDescriptionFormat

instances

  

List of StorageContainerInstance

  

43.2.7.2. ProtobufAny

Any contains an arbitrary serialized protocol buffer message along with a URL that describes the type of the serialized message.

Protobuf library provides support to pack/unpack Any values in the form of utility functions or additional generated methods of the Any type.

Example 1: Pack and unpack a message in C++.

Foo foo = ...;
Any any;
any.PackFrom(foo);
...
if (any.UnpackTo(&foo)) {
  ...
}

Example 2: Pack and unpack a message in Java.

Foo foo = ...;
Any any = Any.pack(foo);
...
if (any.is(Foo.class)) {
  foo = any.unpack(Foo.class);
}
// or ...
if (any.isSameTypeAs(Foo.getDefaultInstance())) {
  foo = any.unpack(Foo.getDefaultInstance());
}
Example 3: Pack and unpack a message in Python.
foo = Foo(...)
any = Any()
any.Pack(foo)
...
if any.Is(Foo.DESCRIPTOR):
  any.Unpack(foo)
  ...
Example 4: Pack and unpack a message in Go
foo := &pb.Foo{...}
any, err := anypb.New(foo)
if err != nil {
  ...
}
...
foo := &pb.Foo{}
if err := any.UnmarshalTo(foo); err != nil {
  ...
}

The pack methods provided by protobuf library will by default use 'type.googleapis.com/full.type.name' as the type URL and the unpack methods only use the fully qualified type name after the last '/' in the type URL, for example "foo.bar.com/x/y.z" will yield type name "y.z".

43.2.7.2.1. JSON representation

The JSON representation of an Any value uses the regular representation of the deserialized, embedded message, with an additional field @type which contains the type URL. Example:

package google.profile;
message Person {
  string first_name = 1;
  string last_name = 2;
}
{
  "@type": "type.googleapis.com/google.profile.Person",
  "firstName": <string>,
  "lastName": <string>
}

If the embedded message type is well-known and has a custom JSON representation, that representation will be embedded adding a field value which holds the custom JSON in addition to the @type field. Example (for message [google.protobuf.Duration][]):

{
  "@type": "type.googleapis.com/google.protobuf.Duration",
  "value": "1.212s"
}
Expand
Field NameRequiredNullableTypeDescriptionFormat

typeUrl

  

String

A URL/resource name that uniquely identifies the type of the serialized protocol buffer message. This string must contain at least one \"/\" character. The last segment of the URL’s path must represent the fully qualified name of the type (as in path/google.protobuf.Duration). The name should be in a canonical form (e.g., leading \".\" is not accepted). In practice, teams usually precompile into the binary all types that they expect it to use in the context of Any. However, for URLs which use the scheme http, https, or no scheme, one can optionally set up a type server that maps type URLs to message definitions as follows: * If no scheme is provided, https is assumed. * An HTTP GET on the URL must yield a [google.protobuf.Type][] value in binary format, or produce an error. * Applications are allowed to cache lookup results based on the URL, or have them precompiled into a binary to avoid any lookup. Therefore, binary compatibility needs to be preserved on changes to types. (Use versioned type names to manage breaking changes.) Note: this functionality is not currently available in the official protobuf release, and it is not used for type URLs beginning with type.googleapis.com. As of May 2023, there are no widely used type server implementations and no plans to implement one. Schemes other than http, https (or the empty scheme) might be used with implementation specific semantics.

 

value

  

byte[]

Must be a valid serialized protocol buffer of the above specified type.

byte

43.2.7.3. RuntimeError

Expand
Field NameRequiredNullableTypeDescriptionFormat

error

  

String

  

code

  

Integer

 

int32

message

  

String

  

details

  

List of ProtobufAny

  

43.2.7.4. StorageContainerInstance

ContainerInstanceID allows to uniquely identify a container within a cluster.

Expand
Field NameRequiredNullableTypeDescriptionFormat

instanceId

  

StorageContainerInstanceID

  

containingPodId

  

String

The pod containing this container instance (kubernetes only).

 

containerName

  

String

Container name.

 

containerIps

  

List of string

The IP addresses of this container.

 

started

  

Date

 

date-time

imageDigest

  

String

  

finished

  

Date

The finish time of the container, if it finished.

date-time

exitCode

  

Integer

The exit code of the container. Only valid when finished is populated.

int32

terminationReason

  

String

The reason for the container’s termination, if it finished.

 

43.2.7.5. StorageContainerInstanceID

Expand
Field NameRequiredNullableTypeDescriptionFormat

containerRuntime

  

StorageContainerRuntime

 

UNKNOWN_CONTAINER_RUNTIME, DOCKER_CONTAINER_RUNTIME, CRIO_CONTAINER_RUNTIME,

id

  

String

The ID of the container, specific to the given runtime.

 

node

  

String

The node on which this container runs.

 

43.2.7.6. StorageContainerRuntime

Expand
Enum Values

UNKNOWN_CONTAINER_RUNTIME

DOCKER_CONTAINER_RUNTIME

CRIO_CONTAINER_RUNTIME

43.2.7.7. StoragePod

Pod represents information for a currently running pod or deleted pod in an active deployment.

Expand
Field NameRequiredNullableTypeDescriptionFormat

id

  

String

  

name

  

String

  

deploymentId

  

String

  

namespace

  

String

  

clusterId

  

String

  

liveInstances

  

List of StorageContainerInstance

  

terminatedInstances

  

List of PodContainerInstanceList

Must be a list of lists, so we can perform search queries (does not work for maps that aren’t <string, string>) There is one bucket (list) per container name.

 

started

  

Date

Time Kubernetes reports the pod was created.

date-time

43.2.7.8. V1PodsResponse

Expand
Field NameRequiredNullableTypeDescriptionFormat

pods

  

List of StoragePod

  
Red Hat logoGithubredditYoutubeTwitter

Learn

Try, buy, & sell

Communities

About Red Hat

We deliver hardened solutions that make it easier for enterprises to work across platforms and environments, from the core datacenter to the network edge.

Making open source more inclusive

Red Hat is committed to replacing problematic language in our code, documentation, and web properties. For more details, see the Red Hat Blog.

About Red Hat Documentation

Legal Notice

Theme

© 2026 Red Hat
Back to top